PIC15C56	EQU 1FFh

;-------------------------------;
	ORG	0

	goto 	main

;-------------------------------;
;	REGISTERS
;-------------------------------;
	indir	equ	0x00	;
	tmr0	equ	0x01	;
	pc	equ	0x02	;
	status	equ	0x03	;
	fsr	equ	0x04	;
	serial	equ	0x05	;
	extern	equ	0x06	;
				;
	cmd	equ	0x07	; ॣ 
	addr	equ	0x08	;
	outbit	equ	0x09	;
	count	equ	0x0A	;
				;
;-------------------------------;
;	BITS
;-------------------------------;
	carry	equ	0	;
	zflags	equ	2	;
				;
	cs	equ	0	;
	clock	equ	1	;
	din	equ	2	;
	dout	equ	3	;
				;
	ready	equ	4	;
	read	equ	5	;
	write	equ	6	;
				;
;-------------------------------;
;	CONSTANTS
;-------------------------------;
				;
	data_12	equ	0xAA	;
	data_13 equ	0x5A	;
	data_14	equ	0x64	;
	data_15 equ	0x89	;
				;
;///////////////////////////////;
;	MAIN			;
;-------------------------------;
main				;

	clrf	serial		;
	movlw	b'11111000'	;  
	tris	serial		;
				;
	clrf	extern		;
	movlw	b'00000111'	;
	tris	extern		;
				;
	bsf	extern, read	; .   READ
	bsf	extern, write	; .   WRATE
				;
;-------------------------------;
wt_cs				;
	bsf	extern, dout	;
				;
w_cs	clrwdt			;
	btfss	extern, cs	;
	goto	w_cs		;  CS
				;
;-------------------------------;
rd_com				; ਥ ᮬ ᫨  CS
	clrf	cmd		;
	bcf	extern, read	;
				;
tst11	btfss	extern, clock	;
	goto	tst11		;
tst10	btfsc	extern, clock	;
	goto	tst10		; 1 takt command
				;
tst21	btfss	extern, clock	;
	goto	tst21		;
tst20	btfsc	extern, clock	;
	goto	tst20		; 2 takt command
				;
tst31	btfss	extern, clock	;
	goto	tst31		;
tst30	btfsc	extern, clock	;
	goto	tst30		; 3 takt command ய襭
				;
tst41	btfss	extern, clock	;
	goto	tst41		;
tst40	btfsc	extern, clock	;
	goto	tst40		; 4 takt command
				;
tst51	btfss	extern, clock	;
	goto	tst51		;
tst50	btfsc	extern, clock	;
	goto	tst50		; 5 takt command
				;
tst61	btfss	extern, clock	;
	goto	tst61		;
tst60	btfsc	extern, clock	;
	goto	tst60		;
				;
tst71	btfss	extern, clock	;
	goto	tst71		;
tst70	btfsc	extern, clock	;
	goto	tst70		;
				;
tst81	btfss	extern, clock	;
	goto	tst81		;
tst80	btfsc	extern, clock	;
	goto	tst80		;
				;
tst91	btfss	extern, clock	;
	goto	tst91		;
tst90	btfsc	extern, clock	;
	goto	tst90		;
				;
tst101	btfss	extern, clock	;
	goto	tst101		;
tst100	btfsc	extern, clock	;
	goto	tst100		;
				;
tst111	btfss	extern, clock	;
	goto	tst111		;
tst110	btfsc	extern, clock	;
	goto	tst110		;
				;
tst121	btfss	extern, clock	;
	goto	tst121		;
tst120	btfsc	extern, clock	;
	goto	tst120		;
				;
tst131	btfss	extern, clock	;
	goto	tst131		;
tst130	btfsc	extern, clock	;
	goto	tst130		;
				;
tst141	btfss	extern, clock	;
	goto	tst141		;
tst140	btfsc	extern, clock	;
	goto	tst140		;
				;
	bcf	extern, dout	;
tst151	btfss	extern, clock	;
	goto	tst151		;
tst150	btfsc	extern, clock	;
	goto	tst150		;
				;
tst161	btfss	extern, clock	;
	goto	tst161		;
tst160	btfsc	extern, clock	;
	goto	tst160		;
				;
;-------------------------------;
out_d				;
	clrwdt			;
	clrf	addr		;
				;
out_d1	clrf	outbit		;
	movlw	0x12
	xorwf	addr, 0
	btfsc	status, zflags
	goto	dat_12
	movlw	0x13
	xorwf	addr, 0
	btfsc	status, zflags
	goto	dat_13
	movlw	0x14
	xorwf	addr, 0
	btfsc	status, zflags
	goto	dat_14
	movlw	0x15
	xorwf	addr, 0
	btfsc	status, zflags
	goto	dat_15
	movlw	0x20
	xorwf	addr, 0
	btfsc	status, zflags
	clrf	addr
	goto	out_beg

dat_12	movlw	data_12
	movwf	outbit
	goto	out_beg

dat_13	movlw	data_13
	movwf	outbit
	goto	out_beg

dat_14	movlw	data_14
	movwf	outbit
	goto	out_beg

dat_15	movlw	data_15
	movwf	outbit
	goto	out_beg

out_beg				;
	clrwdt			;
	movlw	8		;
	movwf	count		;
out_lo	rlf	outbit		;
tsdl1	btfss	extern, clock	;
	goto	tsdl1		;
	bcf	extern, dout	;
	btfsc	status, carry	;
	bsf	extern, dout	;
tsdl0	btfsc	extern, clock	;
	goto	tsdl0		; low bite out
	decfsz	count		;
	goto	out_lo		;
	incf	addr
	goto	out_d1		;
				;
;-------------------------------;
END
